> ## Documentation Index
> Fetch the complete documentation index at: https://developers.telnyx.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Extend a number reservation

> Extends reservation expiry time on all phone numbers.



## OpenAPI

````yaml https://telnyx-openapi-ng.s3.us-east-1.amazonaws.com/numbers-identity/ordering.yml post /number_reservations/{number_reservation_id}/actions/extend
openapi: 3.1.0
info:
  title: Telnyx Phone Number Ordering API
  version: 2.0.0
  description: API for ordering phone numbers.
  contact:
    email: support@telnyx.com
servers:
  - url: https://api.telnyx.com/v2
security:
  - bearerAuth: []
paths:
  /number_reservations/{number_reservation_id}/actions/extend:
    post:
      tags:
        - Phone Number Reservations
      summary: Extend a number reservation
      description: Extends reservation expiry time on all phone numbers.
      operationId: ExtendNumberReservationExpiryTime
      parameters:
        - name: number_reservation_id
          in: path
          description: The number reservation ID.
          required: true
          schema:
            type: string
      responses:
        '200':
          $ref: '#/components/responses/NumberReservationResponse'
        '400':
          $ref: '#/components/responses/numbers_BadRequestResponse'
        '401':
          $ref: '#/components/responses/numbers_UnauthorizedResponse'
        '404':
          $ref: '#/components/responses/numbers_NotFoundResponse'
        '422':
          $ref: '#/components/responses/numbers_UnprocessableEntity'
        '500':
          $ref: '#/components/responses/numbers_GenericErrorResponse'
      x-codeSamples:
        - lang: JavaScript
          source: >-
            import Telnyx from 'telnyx';


            const client = new Telnyx({
              apiKey: process.env['TELNYX_API_KEY'], // This is the default and can be omitted
            });


            const response = await
            client.numberReservations.actions.extend('number_reservation_id');


            console.log(response.data);
        - lang: Python
          source: |-
            import os
            from telnyx import Telnyx

            client = Telnyx(
                api_key=os.environ.get("TELNYX_API_KEY"),  # This is the default and can be omitted
            )
            response = client.number_reservations.actions.extend(
                "number_reservation_id",
            )
            print(response.data)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/team-telnyx/telnyx-go\"\n\t\"github.com/team-telnyx/telnyx-go/option\"\n)\n\nfunc main() {\n\tclient := telnyx.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tresponse, err := client.NumberReservations.Actions.Extend(context.TODO(), \"number_reservation_id\")\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", response.Data)\n}\n"
        - lang: Java
          source: >-
            package com.telnyx.sdk.example;


            import com.telnyx.sdk.client.TelnyxClient;

            import com.telnyx.sdk.client.okhttp.TelnyxOkHttpClient;

            import
            com.telnyx.sdk.models.numberreservations.actions.ActionExtendParams;

            import
            com.telnyx.sdk.models.numberreservations.actions.ActionExtendResponse;


            public final class Main {
                private Main() {}

                public static void main(String[] args) {
                    TelnyxClient client = TelnyxOkHttpClient.fromEnv();

                    ActionExtendResponse response = client.numberReservations().actions().extend("number_reservation_id");
                }
            }
        - lang: Ruby
          source: >-
            require "telnyx"


            telnyx = Telnyx::Client.new(api_key: "My API Key")


            response =
            telnyx.number_reservations.actions.extend_("number_reservation_id")


            puts(response)
        - lang: CLI
          source: |-
            telnyx number-reservations:actions extend \
              --api-key 'My API Key' \
              --number-reservation-id number_reservation_id
components:
  responses:
    NumberReservationResponse:
      description: Successful response with details about a number reservation.
      content:
        application/json:
          schema:
            type: object
            title: Number Reservation Response
            properties:
              data:
                $ref: '#/components/schemas/NumberReservation'
    numbers_BadRequestResponse:
      description: >-
        Bad request, the request was unacceptable, often due to missing a
        required parameter.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/numbers_Errors'
    numbers_UnauthorizedResponse:
      description: Unauthorized
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/numbers_Errors'
          examples:
            Authentication Failed:
              value:
                errors:
                  - code: '10009'
                    title: Authentication failed
                    detail: Could not understand the provided credentials.
                    meta:
                      url: https://developers.telnyx.com/docs/overview/errors/10009
    numbers_NotFoundResponse:
      description: The requested resource doesn't exist.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/numbers_Errors'
    numbers_UnprocessableEntity:
      description: Unprocessable entity. Check the 'detail' field in response for details.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/numbers_Errors'
    numbers_GenericErrorResponse:
      description: Unexpected error
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/numbers_Errors'
  schemas:
    NumberReservation:
      properties:
        id:
          type: string
          format: uuid
          example: 12ade33a-21c0-473b-b055-b3c836e1c292
          readOnly: true
        record_type:
          type: string
          example: number_reservation
          readOnly: true
        phone_numbers:
          type: array
          items:
            $ref: '#/components/schemas/ReservedPhoneNumber'
        status:
          type: string
          enum:
            - pending
            - success
            - failure
          description: The status of the entire reservation.
          readOnly: true
        customer_reference:
          type: string
          description: A customer reference string for customer look ups.
          example: MY REF 001
        created_at:
          type: string
          format: date-time
          description: >-
            An ISO 8901 datetime string denoting when the numbers reservation
            was created.
          example: '2018-01-01T00:00:00.000000Z'
          readOnly: true
        errors:
          type: string
          description: Errors the reservation could happen upon
          example: Number is already on hold
          readOnly: true
        updated_at:
          type: string
          format: date-time
          description: >-
            An ISO 8901 datetime string for when the number reservation was
            updated.
          example: '2018-01-01T00:00:00.000000Z'
          readOnly: true
      example:
        id: 12ade33a-21c0-473b-b055-b3c836e1c292
        record_type: number_reservation
        phone_numbers:
          - id: 12ade33a-21c0-473b-b055-b3c836e1c292
            record_type: reserved_phone_number
            phone_number: '+19705555098'
            status: pending
            created_at: '2018-01-01T00:00:00.000000Z'
            updated_at: '2018-01-01T00:00:00.000000Z'
            expired_at: '2018-01-01T00:00:00.000000Z'
            errors: Number is already on hold
        status: pending
        customer_reference: MY REF 001
        created_at: '2018-01-01T00:00:00.000000Z'
        updated_at: '2018-01-01T00:00:00.000000Z'
      type: object
    numbers_Errors:
      properties:
        errors:
          type: array
          items:
            $ref: '#/components/schemas/numbers_Error'
      type: object
    ReservedPhoneNumber:
      properties:
        id:
          type: string
          format: uuid
          example: 12ade33a-21c0-473b-b055-b3c836e1c292
          readOnly: true
        errors:
          type: string
          description: Errors the reservation could happen upon
          example: Number is already on hold
          readOnly: true
        record_type:
          type: string
          example: reserved_phone_number
          readOnly: true
        phone_number:
          type: string
          example: '+19705555098'
        status:
          type: string
          enum:
            - pending
            - success
            - failure
          description: The status of the phone number's reservation.
          example: success
          readOnly: true
        created_at:
          type: string
          format: date-time
          description: >-
            An ISO 8901 datetime string denoting when the individual number
            reservation was created.
          example: '2018-01-01T00:00:00.000000Z'
          readOnly: true
        updated_at:
          type: string
          format: date-time
          description: >-
            An ISO 8901 datetime string for when the the individual number
            reservation was updated.
          example: '2018-01-01T00:00:00.000000Z'
          readOnly: true
        expired_at:
          type: string
          format: date-time
          description: >-
            An ISO 8901 datetime string for when the individual number
            reservation is going to expire
          example: '2018-01-01T00:00:00.000000Z'
          readOnly: true
      example:
        id: 12ade33a-21c0-473b-b055-b3c836e1c292
        record_type: reserved_phone_number
        phone_number: '+19705555098'
        status: pending
        created_at: '2018-01-01T00:00:00.000000Z'
        updated_at: '2018-01-01T00:00:00.000000Z'
        expired_at: '2018-01-01T00:00:00.000000Z'
      type: object
    numbers_Error:
      properties:
        code:
          type: string
          example: '10007'
        title:
          type: string
          example: Unexpected error
        detail:
          type: string
          example: An unexpected error occured.
        source:
          type: object
          properties:
            pointer:
              description: JSON pointer (RFC6901) to the offending entity.
              type: string
              example: /base
            parameter:
              description: Indicates which query parameter caused the error.
              type: string
        meta:
          type: object
          properties:
            url:
              type: string
              description: URL with additional information on the error.
              example: https://developers.telnyx.com/docs/overview/errors/10015
      type: object
  securitySchemes:
    bearerAuth:
      scheme: bearer
      type: http

````